Resolution:  Affected version:  

Description

When you attempt to import the attached CSV file (test.csv), the following error message is displayed:

The file is not a CSV file or does not match the settings below (Unquoted fields do not allow new 

line <"\r\n"> in line 1.)
This error occurs when the CSV file contains values with newline characters ("\n") inside double-quoted fields, and the lines end with

DOS-style line endings ("\r\n"). If the file uses UNIX-style line endings (\n), the error does not occur.

This type of CSV file can be generated by Microsoft Excel when cells contain line breaks.
History

#1 - 2024-10-07 08:28 - Go MAEDA

I found that the error occurs only when quoted values that contain "\n" exist in the first line.

redmine-app(prod)> CSV.parse(%Q|FieldName1,"Field\nName2"\r\nValue1,"Value2"|)

/Users/maeda/redmines/gems/ruby/3.3.0/gems/irb-1.14.1/lib/irb.rb:1260:in `full_message': Any value after quote

d field isn't allowed in line 1. (CSV::MalformedCSVError)

 No problem when it exists in the second line or later.

redmine-app(prod)> CSV.parse(%Q|FieldName1,"FieldName2"\r\nValue1,"Value\n2"|)

=> [["FieldName1", "FieldName2"], ["Value1", "Value\n2"]]

 Setting the row_sep option also avoids the error.

redmine-app(prod)> CSV.parse(%Q|FieldName1,"Field\nName2"\r\nValue1,"Value2"|,  row_sep: "\r\n")

=> [["FieldName1", "Field\nName2"], ["Value1", "Value2"]]

#2 - 2024-11-04 06:07 - Go MAEDA

- File 41434-csv-crlf.patch added

The attached patch should fix the issue.

#3 - 2024-11-10 08:27 - Go MAEDA

- Target version set to 6.1.0

Setting the target version to 6.1.0.

Files

test.csv 62 Bytes 2024-10-04 Go MAEDA

clipboard-202410050652-xaakj.png 131 KB 2024-10-04 Go MAEDA

spreadsheet.png 16.7 KB 2024-10-04 Go MAEDA

41434-csv-crlf.patch 1.17 KB 2024-11-04 Go MAEDA
